/******************************************************************************
 file : bookmark.js
 description : ubN}[NIuWFNg
 @@@@@@@ubN}[Nt@C̊Ǘ
               ubN}[Nt@CXBELɏB
 date : 2009/02
 update: 2011/7/22	ubN}[Ny[W(WebHTML, Windows help&support)Jۂ
 									\G[B̉eŃubN}[Ny[WJȂsCB
 		2015/4/22	Adobe Acrobat Reader DCΉ
 Copyright (C) Epson Direct Corporation 2008-2015
******************************************************************************/

var dBook;
var bookmarkXml;
var bookmarkXslt;
var docXml;
var docXslt;
var xbel;

function Bookmark(xml, xslt) {
	bookmarkXml = xml;
	bookmarkXslt = xslt;
	docXml = new ActiveXObject("MSXML2.DOMDocument.3.0");
	docXml.async = false;
	if(!loadBookmark()) {
		createNewXml();
	}
	else {
		xbel = docXml.documentElement;
	}
	docXslt = new ActiveXObject("MSXML2.DOMDocument.3.0");
	docXslt.load(bookmarkXslt);
}

function loadBookmark() {
	try {
		return docXml.load(bookmarkXml);
	}
	catch(e) {
		alert("ubN}[Nt@C̓ǂݍ݂Ɏs܂B\r\nG[ = " + e.message);
		return false;
	}
}

function saveBookmark() {
	try {
		var rv = docXml.save(bookmarkXml);

		return rv;
	}
	catch(e) {
		alert("ubN}[Nt@Cۑł܂łB\r\nG[ = " + e.message);
		return false;
	}
}

function createNewXml() {
	//docXml.appendChild(docXml.createProcessingInstruction('xml', 'version="1.0" encoding="Shift_JIS"'));
	docXml.appendChild(docXml.createProcessingInstruction('xml', 'version="1.0" encoding="utf-8"'));
	var xslt = bookmarkXslt;
	var lindex;
	if((lindex = bookmarkXslt.lastIndexOf('\\')) >= 0) {
		xslt = bookmarkXslt.substr(lindex + 1);
	}
	docXml.appendChild(docXml.createProcessingInstruction('xml-stylesheet', 'type="text/xsl" href="' + xslt + '"'));
	xbel = docXml.createElement('xbel');
	docXml.appendChild(xbel);
	xbel.setAttribute("version", "1.0");
	xbel.appendChild(docXml.createElement('title')).text = "Support Portal";
	saveBookmark();
}

function Bookmark.prototype.view(contents) {
	contents.innerHTML = docXml.documentElement.transformNode(docXslt);
}

function getMatchIndex(bookmark_list, folder, title, link, type, topic, anchor, map, keyword, faqid) {
	var match = -1;
	for(var i = 0; i < bookmark_list.length; i++) {
		if(bookmark_list[i].parentNode == folder) {
			if(bookmark_list[i].getAttribute("href") == link) {
				switch(type) {
				case "WEBHTML":
					if(bookmark_list[i].getAttribute("faqid") == faqid) {
						match = i;
						return match;
					}
					break;
					
				case "HTML":
				case "PDF":
				case "TXT":
				case "HTML_MANUAL":
				case "PDF_MANUAL":
					match = i;
					return match;
					
				case "CHM":
					if(bookmark_list[i].getAttribute("anchor") == anchor && bookmark_list[i].getAttribute("topic") == topic) {
						match = i;
						return match;
					}
					break;
					
				case "H1S":
				case "HXS":
				case "MSHC":
					if(bookmark_list[i].getAttribute("topic") == topic) {
						match = i;
						return match;
					}
					break;
					
				case "HLP":
					if(bookmark_list[i].getAttribute("map") == map && bookmark_list[i].getAttribute("keyword") == keyword) {
						match = i;
						return match;
					}
					break;
				}
			}
		}
	}
	return match;
}

function Bookmark.prototype.add(gid, title, link, type, topic, anchor, map, keyword, faqid, force) {
	var folder_list = xbel.getElementsByTagName('folder');
	var folder = xbel;
	for(var i = 0; i < folder_list.length; i++) {
		var id = folder_list[i].getAttribute("id");
		if(id == gid) {	// group id vĂꍇ
			folder = folder_list[i];
			break;
		}
	}
	var bookmark_list = folder.getElementsByTagName('bookmark');
	if(faqid != "") type = "WEBHTML";
	var match = getMatchIndex(bookmark_list, folder, title, link, type, topic, anchor, map, keyword, faqid);
	if(match == -1) {
		var bookmark = folder.appendChild(docXml.createElement('bookmark'));
		bookmark.setAttribute("href", link);
		if(link.indexOf("http://") == 0) {
			type = "WEBHTML";
		}
		bookmark.setAttribute("type", type);
		switch(type) {
		case "HTML":
		case "HTML_MANUAL":
			bookmark.setAttribute("frame", top.gsFrame);
			break;
			
		case "CHM":
			bookmark.setAttribute("anchor", anchor);
			bookmark.setAttribute("topic", topic);
			break;
			
		case "H1S":
		case "HXS":
		case "MSHC":
			bookmark.setAttribute("topic", topic);
			break;
			
		case "HLP":
			bookmark.setAttribute("map", map);
			bookmark.setAttribute("keyword", keyword);
			break;

		case "WEBHTML":
			bookmark.setAttribute("faqid", faqid);
			break;
		}
		bookmark.appendChild(docXml.createElement('title')).text = title;
		saveBookmark();
		return true;
	}
	else {
		if(force) {
			bookmark_list[match].childNodes.item(0).text = title;
			saveBookmark();
			return true;
		}
	}
	return false;
}

function Bookmark.prototype.remove(gid, title, link, type, topic, anchor, map, keyword, faqid) {
	var folder_list = xbel.getElementsByTagName('folder');
	var folder = xbel;
	for(var i = 0; i < folder_list.length; i++) {
		var id = folder_list[i].getAttribute("id");
		if(id == gid) {	// group id vĂꍇ
			folder = folder_list[i];
			break;
		}
	}
	var bookmark_list = folder.getElementsByTagName('bookmark');
	var match = getMatchIndex(bookmark_list, folder, title, link, type, topic, anchor, map, keyword, faqid);
	if(match >= 0) {
		folder.removeChild(bookmark_list[match]);
		saveBookmark();
		return true;
	}
	return false;
}

function Bookmark.prototype.removeGroup(gid) {
	var folder_list = xbel.getElementsByTagName('folder');
	for(var i = 0; i < folder_list.length; i++) {
		var id = folder_list[i].getAttribute("id");
		if(id == gid) {	// group id vĂꍇ
			xbel.removeChild(folder_list[i]);
			saveBookmark();
			return true;
		}
	}
	return false;
}

function Bookmark.prototype.move(src, dir) {
	var breplace = false;
	var folder_list = xbel.getElementsByTagName('folder');
	var folder = xbel;
	for(var i = 0; i < folder_list.length; i++) {
		var id = folder_list[i].getAttribute("id");
		if(id == dir.gid) {	// group id vĂꍇ
			folder = folder_list[i];
			break;
		}
	}
	var bookmark_list_move_chk = folder.getElementsByTagName('bookmark');
	var move_chk = getMatchIndex(bookmark_list_move_chk, folder, src.title, src.link, src.type, src.topic, src.anchor, src.map, src.keyword, src.faqid);
	if(move_chk >= 0 && src.gid != dir.gid && dir.gid != "tdtop") {// && folder != xbel) {
		var bmdir = bookmark_list_move_chk[move_chk];
		if(confirm("ړɓ̃ubN}[N܂B\r\nu܂H\r\n\r\nړubN}[NF"+src.title+"\r\nړubN}[NF"+bmdir.childNodes.item(0).text+"\r\nNF"+bmdir.getAttribute("href"))) {
			breplace = true;
			// u
			dir.title = bmdir.childNodes.item(0).text;
			dir.link = bmdir.getAttribute("href");
			dir.type = bmdir.getAttribute("type");
			dir.topic = bmdir.getAttribute("topic");
			dir.anchor = bmdir.getAttribute("anchor");
			dir.map = bmdir.getAttribute("map");
			dir.keyword = bmdir.getAttribute("keyword");
			dir.faqid = bmdir.getAttribute("faqid");
			dir.frame = bmdir.getAttribute("frame");
		}
		else return -1;
	}
	
	folder_list = xbel.getElementsByTagName('folder');
	folder = xbel;
	for(var i = 0; i < folder_list.length; i++) {
		var id = folder_list[i].getAttribute("id");
		if(id == src.gid) {	// group id vĂꍇ
			folder = folder_list[i];
			break;
		}
	}
	var bookmark_list = folder.getElementsByTagName('bookmark');
	var match = getMatchIndex(bookmark_list, folder, src.title, src.link, src.type, src.topic, src.anchor, src.map, src.keyword, src.faqid);
	if(match >= 0) {
		folder.removeChild(bookmark_list[match]);
	}
	else return 0;

	folder_list = xbel.getElementsByTagName('folder');
	folder = xbel;
	for(var i = 0; i < folder_list.length; i++) {
		var id = folder_list[i].getAttribute("id");
		if(id == dir.gid) {	// group id vĂꍇ
			folder = folder_list[i];
			break;
		}
	}
	if(dir.folder == 'no') {
		var bookmark_list_dir = folder.getElementsByTagName('bookmark');
		var match_dir = getMatchIndex(bookmark_list_dir, folder, dir.title, dir.link, dir.type, dir.topic, dir.anchor, dir.map, dir.keyword, dir.faqid);
	
		if(match_dir >= 0) {
			folder.insertBefore(bookmark_list[match], bookmark_list_dir[match_dir]);
			folder.removeChild(bookmark_list_dir[match_dir]);
			if(!breplace) {
				folder.insertBefore(bookmark_list_dir[match_dir], bookmark_list[match]);
			}
			saveBookmark();
			return 1;
		}
	}
	else {	// tH_܂XBEL
		if(folder != xbel) {
			var bookmark_list_dir = folder.getElementsByTagName('bookmark');
			if(bookmark_list_dir.length >= 1) {	// Pȏ̂Ƃ́Aŏ̃ubN}[N̑Oɑ}
				folder.insertBefore(bookmark_list[match], bookmark_list_dir[0]);
			}
			else {
				folder.appendChild(bookmark_list[match]);
			}
		}
		else {
			var bookmark_list_dir = folder.getElementsByTagName('bookmark');
			var count = 0;
			var findex = -1;
			for(var i = 0; i < bookmark_list_dir.length; i++) {
				if(bookmark_list_dir[i].parentNode == xbel) {
					if(findex < 0) findex = i;
					count++;
				}
			}
			if(count >= 1) {
				folder.insertBefore(bookmark_list[match], bookmark_list_dir[findex]);
			}
			else {
				folder.appendChild(bookmark_list[match]);
			}
		}
		saveBookmark();
		return 1;
	}
	return 0;
}

function Bookmark.prototype.rename(gid, title, link, type, topic, anchor, map, keyword, faqid, newtitle) {
	var folder_list = xbel.getElementsByTagName('folder');
	var folder = xbel;
	for(var i = 0; i < folder_list.length; i++) {
		var id = folder_list[i].getAttribute("id");
		if(id == gid) {	// group id vĂꍇ
			folder = folder_list[i];
			break;
		}
	}
	var bookmark_list = folder.getElementsByTagName('bookmark');
	var match = getMatchIndex(bookmark_list, folder, title, link, type, topic, anchor, map, keyword, faqid);
	if(match >= 0) {
		bookmark_list[match].childNodes.item(0).text = newtitle;
		saveBookmark();
		return true;
	}
	return false;
}

function Bookmark.prototype.renameGroup(gid, newtitle) {
	var folder_list = xbel.getElementsByTagName('folder');
	for(var i = 0; i < folder_list.length; i++) {
		var id = folder_list[i].getAttribute("id");
		if(id == gid) {	// group id vĂꍇ
			folder_list[i].childNodes.item(0).text = newtitle;
			saveBookmark();
			return true;
		}
	}
	return false;
}

function Bookmark.prototype.links(gid) {
	var folder_list = xbel.getElementsByTagName('folder');
	var folder = xbel;
	for(var i = 0; i < folder_list.length; i++) {
		var id = folder_list[i].getAttribute("id");
		if(id == gid) {	// group id vĂꍇ
			folder = folder_list[i];
			break;
		}
	}
	var linkList = new Array();
	var bookmark_list = xbel.getElementsByTagName('bookmark');
	for(var i = 0; i < bookmark_list.length; i++) {
		var bl = bookmark_list[i];
		if(bl.parentNode == folder) {
			// [title, href, type]
			linkList.push([bl.childNodes.item(0).text, bl.getAttribute('href'), bl.getAttribute('type')]);
		}
	}
	return linkList;
}

function Bookmark.prototype.groups() {
	var folder_list = xbel.getElementsByTagName('folder');
	var groupList = new Array();
	for(var i = 0; i < folder_list.length; i++) {
		var folder = folder_list[i];
		groupList[i] = [folder.getAttribute("id"), folder.childNodes.item(0).text];
	}
	return groupList;
}

function Bookmark.prototype.makeGroup(group, pgid) {
	var folder_list = xbel.getElementsByTagName('folder');
	var folder = xbel;
	for(var i = 0; i < folder_list.length; i++) {
		var id = folder_list[i].getAttribute("id");
		if(id == pgid) {	// parent group id vĂꍇ
			folder = folder_list[i];
			break;
		}
		if(folder_list[i].childNodes.item(0).text == group) {	// ꖼ̏ꍇ
			return false;
		}
	}
	var newfolder = docXml.createElement('folder');
	folder.appendChild(newfolder);
	newfolder.setAttribute("id", "f" + folder_list.length.toString());
	newfolder.setAttribute("folded", "no");
	newfolder.appendChild(docXml.createElement('title')).text = group;
	saveBookmark();
	return true;
}

function Bookmark.prototype.getGroupId(group) {
	var gid = -1;
	var folder_list = xbel.getElementsByTagName('folder');
	var folder = xbel;
	for(var i = 0; i < folder_list.length; i++) {
		if(folder_list[i].childNodes.item(0).text == group) {
			gid = folder_list[i].getAttribute("id");
			break;
		}
	}
	return gid;
}

function Bookmark.prototype.setFolded(gid, yn) {
	var folder_list = xbel.getElementsByTagName('folder');
	for(var i = 0; i < folder_list.length; i++) {
		if(folder_list[i].getAttribute("id") == gid) {
			folder_list[i].setAttribute("folded") = yn;
			break;
		}
	}
}

function Bookmark.prototype.save() {
	saveBookmark();
}

function Bookmark.prototype.groupOpen(group) {
	if(top.gbContextmenu) return;

	if(group.folded == "yes") {
		group.className = "minus";
		group.folded = "no";
		var pn = group.childNodes(0);
		for(var i = 0; i < pn.childNodes.length; i++) {
			if(pn.childNodes(i).tagName == "UL" && (pn.childNodes(i).id == group.id)) {
				pn.childNodes(i).style.display = "block";
			}
		}
	}
	else {
		group.className = "plus";;
		group.folded = "yes";
		var pn = group.childNodes(0);
		for(var i = 0; i < pn.childNodes.length; i++) {
			if(pn.childNodes(i).tagName == "UL" && (pn.childNodes(i).id == group.id)) {
				pn.childNodes(i).style.display = "none";
			}
		}
	}
	var folder_list = xbel.getElementsByTagName('folder');
	for(var i = 0; i < folder_list.length; i++) {
		if(folder_list[i].getAttribute("id") == group.id) {
			folder_list[i].setAttribute("folded") = group.folded;
			break;
		}
	}
	saveBookmark();
}

function bmList() {
	var folder_list = xbel.getElementsByTagName('folder');
	var linkList = new Array();
	var bookmark_list = xbel.getElementsByTagName('bookmark');
	var index = 0;
	for(var i = 0; i < bookmark_list.length; i++) {
		var bl = bookmark_list[i];
		if(bl.parentNode == xbel) {
			linkList.push(
				{	link:bl.getAttribute('href'),
					ftype:bl.getAttribute('type'), 
					atitle:bl.childNodes.item(0).text,
					topic:bl.getAttribute('topic'),
					anchor:bl.getAttribute('anchor'),
					map:bl.getAttribute('map'),
					keyword:bl.getAttribute('keyword'),
					faqid:bl.getAttribute('faqid'),
					gid:"",
					frame:bl.getAttribute('frame'),
					index:index
				 });
			index++;
		}
	}
	for(var n = 0; n < folder_list.length; n++) {
		for(var i = 0; i < bookmark_list.length; i++) {
			var bl = bookmark_list[i];
			if(bl.parentNode == folder_list[n]) {
				linkList.push(
					{	link:bl.getAttribute('href'),
						ftype:bl.getAttribute('type'), 
						atitle:bl.childNodes.item(0).text,
						topic:bl.getAttribute('topic'),
						anchor:bl.getAttribute('anchor'),
						keyword:bl.getAttribute('keyword'),
						faqid:bl.getAttribute('faqid'),
						gid:bl.parentNode.getAttribute('id'),
						frame:bl.getAttribute('frame'),
						index:index
					 });
				index++;
			}
		}
	}
	return linkList;
}

Bookmark.prototype.bookmarkList = bmList;

var gnewurl;
var giInt0;
function viewTopic() {
	if(top.gbPageLoaded) {
		try {
			if(typeof top.main.contents.main.page.document == 'unknown') return;
			clearInterval(giInt0);
			top.gobjPCUU.DisplayTask(top.gsTopic, top.main.contents.main.page.document.body.clientWidth, top.main.contents.main.page.document.body.clientHeight, top.main.contents.main.page.screenTop + 4, top.main.contents.main.page.screenLeft + 3);
		}
		catch(e) {
			clearInterval(giInt0);
		}
	}
}

var giInt1;
function viewWeb() {
	if(top.gbPageLoaded) {
		try {
			if(typeof top.main.contents.main.page.document == 'unknown') return;
			clearInterval(giInt1);
			if(top.gsFAQID != null && top.gsFAQID != "") {
				var post = "PROD=" + top.footerarea.getProductCategory() + "&";
				post += "MAIN3=" + top.footerarea.getOSCategory() + "&";
				post += "SERIALID=" + top.footerarea.getSerialNumber() + "&";
				post += "FAQID=" + top.gsFAQID;
				top.windowOpen(top.gsHREFContents, "", top.main.contents.main.page.document.body.clientWidth, top.main.contents.main.page.document.body.clientHeight, top.main.contents.main.page.screenTop + 4, top.main.contents.main.page.screenLeft + 3, post);
			}
			else {
				top.windowOpen(top.gsHREFContents, "", top.main.contents.main.page.document.body.clientWidth, top.main.contents.main.page.document.body.clientHeight, top.main.contents.main.page.screenTop + 4, top.main.contents.main.page.screenLeft + 3);
			}
		}
		catch(e) {
			clearInterval(giInt1);
		}
	}
}

function Bookmark.prototype.viewBookmark(bookmark) {
	if(bookmark.index == undefined) {
		var bl = bmList();
		var match = -1;
		for(var i = 0; i < bl.length; i++) {
			if(bl[i].gid == bookmark.parentNode.getAttribute("id") && bookmark.link == bl[i].link) {
				switch(bookmark.ftype) {
				case "WEBHTML":
					if(bookmark.getAttribute("faqid") == bl[i].faqid) {
						match = i;
					}
					break;
					
				case "HTML":
				case "PDF":
				case "TXT":
				case "HTML_MANUAL":
				case "PDF_MANUAL":
					match = i;
					break;
					
				case "CHM":
					if(bookmark.getAttribute("anchor") == bl[i].anchor && bookmark.getAttribute("topic") == bl[i].topic) {
						match = i;
					}
					break;
					
				case "H1S":
				case "HXS":
				case "MSHC":
					if(bookmark.getAttribute("topic") == bl[i].topic) {
						match = i;
					}
					break;
					
				case "HLP":
					if(bookmark.getAttribute("map") == bl[i].map && bookmark.getAttribute("keyword") == bl[i].keyword) {
						match = i;
					}
					break;
				}
				if(match >= 0) break;
			}
		}
		if(match >= 0) {
			top.giContentsIndex = bl[match].index;
		}
	}
	if(top.gbContextmenu) return;
	var icons = top.main.contents.main.icon;
	icons.dirIcons();
	top.golastSel = bookmark;
	top.golastSelLink = bookmark.link;

		top.gsHREFContents = bookmark.link;
		top.gsFileType = bookmark.ftype;
		top.gsTitleContents = bookmark.atitle;
		top.gsAnchorName = bookmark.anchor;
		top.gsTopic = bookmark.topic;
		top.gsMap = bookmark.map;
		top.gsKeyword = bookmark.keyword;
		top.gsFAQID = bookmark.faqid;
		top.gsFrame = bookmark.frame;
		top.clearHistory();
		top.main.contents.main.page.location.href = "file:///" + top.gsCurDirS + "bookmark/page.html";	// dummy
		switch(bookmark.ftype) {
		case "HTML":
		case "HTML_MANUAL":
			top.giTypeContents = top.HTML_LOCAL_CONTENT;
			if(bookmark.frame != "no") {
				top.main.contents.main.page.location.href = bookmark.link;
				top.setHistory(top.gsHREFContents, top.gsTitleContents, top.gsFileType);
				top.startContentsElementDisable(top.main.contents.main.page, true);
				icons.enableIcon("print", true);
				icons.enableIcon("bookmark", true);
			}
			else {
				top.gbPageLoaded = false;
				top.main.contents.main.page.location.href = top.gsCurDirS + "bookmark/page.html";
				top.startUpdateFrame();
				clearInterval(giInt1);
				giInt1 = setInterval(viewWeb, 50);
				icons.enableIcon("fontsmall", false);
				icons.enableIcon("fontbig", false);
				icons.enableIcon("print", false);
				icons.enableIcon("bookmark", true);
			}
			
			break;
		case "WEBHTML":
			top.giTypeContents = top.HTML_WEB_CONTENT;
			top.gbPageLoaded = false;
			top.main.contents.main.page.location.href = "file:///" + top.gsCurDirS + "bookmark/page.html";
			top.startUpdateFrame();
			clearInterval(giInt1);
			giInt1 = setInterval(viewWeb, 50);
			icons.enableIcon("fontsmall", false);
			icons.enableIcon("fontbig", false);
			icons.enableIcon("print", false);
			icons.enableIcon("bookmark", true);
			break;
		case "PDF":
		case "PDF_MANUAL":
			top.giTypeContents = top.PDF_CONTENT;
			gnewurl = bookmark.link;
			top.gsFile = gnewurl.split('#')[0];
			top.gsPage = gnewurl.substr(gnewurl.indexOf("#page=")).split('&')[0].substr(6);
			top.gsFile = top.gsFile.replace('file:///', '');
			try {
				switch(top.gobjPDF_type) {
				case 1:
					break;
				case 2:
					top.gobjPDF.src = "dummy";	// DCΉ(2015/4/22)
					break;
				}
			} catch(e) {}
			top.main.contents.main.page.location.href = top.gsCurDirS + "view.html";
			top.startUpdateFrame();
			top.setHistory(top.gsHREFContents, top.gsTitleContents, top.gsFileType);
			icons.enableIcon("fontsmall", false);
			icons.enableIcon("fontbig", false);
			icons.enableIcon("print", false);
			icons.enableIcon("bookmark", true);
			break;
		case "TXT":
			top.giTypeContents = top.TEXT_CONTENT;
			top.main.contents.main.page.location.href = bookmark.link;
			top.setHistory(top.gsHREFContents, top.gsTitleContents, top.gsFileType);
			top.startUpdateFrame();
			icons.enableIcon("fontsmall", false);
			icons.enableIcon("fontbig", false);
			icons.enableIcon("print", true);
			icons.enableIcon("bookmark", true);
			break;
		case "CHM":
			// JgfBNgύXȂƁACHMt@Cɕ\ȂB
			var lastIndex = bookmark.link.lastIndexOf("/", bookmark.link.length);
			top.gobjWS.CurrentDirectory = bookmark.link.substring(0, lastIndex);	// JgfBNg̕ύXB
			top.giTypeContents = top.WIN_CONTENT;
			top.main.contents.main.page.location.href = "ms-its:" + bookmark.link + "::/" + bookmark.topic;
			top.golastSelLink = bookmark.link + "::/" + bookmark.topic;
			top.setHistory("ms-its:" + bookmark.link + "::/" + bookmark.topic, top.gsTitleContents, top.gsFileType);
			top.startContentsElementDisable(top.main.contents.main.page, true);
			icons.enableIcon("print", true);
			icons.enableIcon("bookmark", true);
			break;
		case "H1S":
		case "HXS":
		case "MSHC":
			top.giTypeContents = top.WIN_CONTENT;
			top.gbPageLoaded = false;
			top.main.contents.main.page.location.href = "file:///" + top.gsCurDirS + "bookmark/page.html";
			top.startUpdateFrame();
			top.gobjPCUU.CloseTask();
			top.gsTopic = bookmark.topic;
			clearInterval(giInt0);
			giInt0 = setInterval(viewTopic, 50);
			icons.enableIcon("fontsmall", false);
			icons.enableIcon("fontbig", false);
			icons.enableIcon("print", false);
			icons.enableIcon("bookmark", true);
			break;
		case "HLP":
			top.giTypeContents = top.WIN_CONTENT;
			top.main.contents.main.page.location.href = top.gsCurDirS + "bookmark/page.html";
			top.startUpdateFrame();
			break;
		}
}

function getElementPosition(element) {
	var left = 0;
	var top = 0;
	var elem = element;

	left += 7;
	while (elem) {
		left += elem.offsetLeft;
		top += elem.offsetTop;
		elem = elem.offsetParent;
	}

	return ({left: left, top: top});
}

function Bookmark.prototype.popup(title, show) {
	var div = document.getElementById('popup');
	
	if(show) {
		div.style.display = "block";
		var pos = getElementPosition(event.srcElement);
		div.style.pixelLeft = pos.left;
		div.style.pixelTop = pos.top;
		div.innerText = title;
	}
	else {
		div.style.display = "none";
		div.innerHTML = "";
	}
	return false;
}
