/******************************************************************************
 file : rss.js
 description : RSS
 date : 2012/08
 2012/12/25 RSS UI\sC 
 2012/10/10 Windows 8.1 ǉ
 2014/11/09 RDF N̋@\ύX
 2014/12/08 POSTp[^̕ύX
 
 Copyright (C) Epson Direct Corporation 2008-2014
******************************************************************************/

var RSS_FLAG_NEW = 0;
var RSS_FLAG_UPDATE = 1;
var RSS_FLAG_FUTURE = 2;

function pad0(v, len) {
	if(v.length >= len) return v;
	return new Array(len - v.length + 1).join("0") + v;
}

function cmpdate(a, b) {
	return (parseInt(b) - parseInt(a));
}

function loadRss() {
	// top_main.htmlĂяôŁAdǍ
	if(top.RSS_RDF_LOAD_BLOCK) return;
	top.RSS_RDF_LOAD_BLOCK = true;

	// RDFpXMLDOM object
	var rdf = new ActiveXObject("MSXML2.DOMDocument.3.0"/*"Microsoft.XMLDOM"*/);
	rdf.async = false;	// 񓯊ݒ
	rdf.load(top.RSS_URL);

	if(rdf.parseError.errorCode != 0) {
		//alert("G[(RDF) : " + rdf.parseError.reason);
		top.RSS_RDF_LOAD_ERROR_MSG = rdf.parseError.reason;
		if(rdf.parseError.line != 0) top.RSS_RDF_LOAD_ERROR_MSG + " L:" + rdf.parseError.line + "";
		return;
	}
	// RDFrdf:li^O擾
	var rdf_list = rdf.selectNodes('//channel/items/rdf:Seq/rdf:li');
	var res_list = new Array();
	// rdf:li^Ȏl擾
	for(i = 0;i < rdf_list.length;i++){
		res_list[i] = rdf_list.item(i).getAttributeNode('rdf:resource').nodeValue;
	}
	top.RSS_RESOURCE_COUNT = res_list.length;
	// RDFitem^O擾
	top.RSS_ITEM_COUNT = 0;	// RDF item̃Zbg
	var id = 1000000;		// 1000000܂ID蓖ĂB
	var os = getWinOS().toUpperCase().replace(/ /g, '');	// Xy[X폜
	var product = getProductName().toUpperCase();
	for(i = 0; i < top.RSS_RESOURCE_COUNT; i++) {
		var item_list = rdf.selectNodes("//item[@rdf:about='" + res_list[i] + "']");
		if(item_list.length > 0) {
			var item = item_list.item(0);	// vŏitem̂ݒo
			var models = item.selectSingleNode('EDC_model').nodeTypedValue.toUpperCase().split(',');	// EDC_model , split
			var model_match = false;
			if(models.length == 0) model_match = true;	// EDC_modelwȂꍇ͈vƂB
			for(n = 0; n < models.length; n++) {
				if(models[n] == product || models[n] == "ALL") {
					model_match = true;
					break;
				}
			}
			var oss = item.selectSingleNode('EDC_os').nodeTypedValue.toUpperCase().split(',');
			var os_match = false;
			if(oss.length == 0) os_match = true;		// EDC_oswȂꍇ͈vƂB
			for(n = 0; n < oss.length; n++) {
				if(oss[n].replace(/ /g, '') == os || oss[n] == "ALL") {
					os_match = true;
					break;
				}
			}
			var enddate = item.selectSingleNode('EDC_enddate').nodeTypedValue.replace(/-/g, '');		// JI@EDC_enddate  - 폜
			var enddate_ok = false;
			if(enddate == "" || parseInt(enddate) >= parseInt(top.TODAY_DATE)) {	// JI߂ĂȂ
				enddate_ok = true;
			}
			if(model_match && os_match && enddate_ok) {	// Ώۋ@vAΏOSvAJԂłꍇ
				var date = item.selectSingleNode('dc:date').nodeTypedValue.replace(/-/g, '');	// dc:date  - 폜
				if(id > 0) --id;
				var ids = top.RSS_DATE_ID[top.RSS_ITEM_COUNT] = date + pad0(String(id), 6);		// N̏ꍇARDF̐擪ɋ߂̂łV̂ƂB
				if(parseInt(date) <= parseInt(top.TODAY_DATE)) {
					if(parseInt(date) >= parseInt(top.LASTEXEC_DATE)) {
						top.RSS_ITEM_FLAG[ids] = RSS_FLAG_NEW;
						top.RSS_NEW_ITEM_EXIST = true;
					}
					else {
						top.RSS_ITEM_FLAG[ids] = RSS_FLAG_UPDATE;
						top.RSS_UPDATE_ITEM_EXIST = true;
					}
				}
				else {
					top.RSS_ITEM_FLAG[ids] = RSS_FLAG_FUTURE;
				}
				top.RSS_ITEM_TITLE[ids] = item.selectSingleNode('title').nodeTypedValue;
				top.RSS_ITEM_LINK[ids] = item.selectSingleNode('link').nodeTypedValue;
				top.RSS_ITEM_DESCRIPTION[ids] = item.selectSingleNode('description').nodeTypedValue;
				top.RSS_ITEM_PRIORITY[ids] = item.selectSingleNode('EDC_priority').nodeTypedValue;
				top.RSS_ITEM_CATEGORY[ids] = item.selectSingleNode('EDC_category').nodeTypedValue;
				top.RSS_ITEM_COUNT++;
				if(top.RSS_ITEM_COUNT >= top.RSS_RESOURCE_COUNT) break;	// I
			}
		}
	}
	if(top.RSS_ITEM_COUNT > 0) {
		// Vɕבւ
		top.RSS_DATE_ID.sort(cmpdate);
	}
}

function initRssMessage() {
	top.gobjWS.CurrentDirectory = top.gsCurDir;	// JgfBNglɖ߂B
	if(!top.RSS_RDF_LOADED) {	// N̂ݓǂݍ݂
		var bNewRss = readReg("newrss");
		if(bNewRss == "true") {
			loadRss();	// RDF̓ǂݍݏ
			top.RSS_RDF_LOADED = true;
		}
	}
	if(top.readReg("newrss") == "true") {
		document.getElementById("rss-body").style.visibility = "visible";
	}
	else {
		document.getElementById("rss-body").style.visibility = "hidden";
	}
	var rss_message = top.RSS_NONE_UPDATE_TEXT;
	if(top.RSS_NEW_ITEM_EXIST) {
		var fs = new ActiveXObject("Scripting.FileSystemObject");
		if(!fs.FileExists(top.RSS_NEW_ICON)) { // New!!ACRt@C݂Ȃ
			document.getElementById("rss_new_text").innerText = top.RSS_NEW_ICON_TEXT;
		}
		else {
			document.getElementById("rss_new").innerHTML = "<img src=\"" + top.RSS_NEW_ICON + "\" />";
		}
		rss_message = top.RSS_NEW_TEXT;
	}
	if(top.RSS_UPDATE_ITEM_EXIST) {
		if(!top.RSS_NEW_ITEM_EXIST) rss_message = top.RSS_UPDATE_TEXT;
		//if(top.RSS_NEW_ITEM_EXIST) rss_message += "<br />" + top.RSS_UPDATE_TEXT;
		//else rss_message = top.RSS_UPDATE_TEXT;
	}
	if(top.RSS_RDF_LOAD_ERROR_MSG.length != 0) {
		var err = document.getElementById("rss_err");
		err.style.visibility = 'visible';
		//err.innerHTML = "<span class='err_title'>RDFǍG[</span>";
		//document.getElementById("rss_err_msg").innerHTML = "<span class='err_msg'>" + top.RSS_RDF_LOAD_ERROR_MSG + "</span>";
		document.getElementById("rss_err_msg").innerHTML = "C^[lbgɐڑĂ";
	}
	else {
		document.getElementById("rss_err").style.visibility = "hidden";
		document.getElementById("rss_err_msg").style.visibility = "hidden";
		document.getElementById("rss_info_msg").innerHTML = rss_message;
	}
}

var gobj;

function openlink(own) {
	if(gobj.RSS_URL_LINK_MODE == 1) {
		var post = "TRANS=" + gobj.RSS_ITEM_LINK[own.id] + "&";
		post += "PROD=" + gobj.footerarea.getProductCategory() + "&";
		post += "MAIN3=" + gobj.footerarea.getOSCategory() + "&";
		post += "SERIALID=" + gobj.footerarea.getSerialNumber();
		gobj.windowOpen(gobj.WEBSUPPORT_URL + "?syori=RSS", "", gobj.main.document.body.clientWidth, gobj.main.document.body.clientHeight, gobj.screenTop + 2, gobj.screenLeft + 2, post);
	}
	else {
		gobj.windowOpen(gobj.RSS_ITEM_LINK[own.id], ""/*gobj.RSS_ITEM_TITLE[own.id]*/, gobj.main.document.body.clientWidth, gobj.main.document.body.clientHeight, gobj.screenTop + 2, gobj.screenLeft + 2);
	}
	return false;
}

function updateRssList() {
	over();
	gobj = window.dialogArguments[0];
	document.title = "m点";//gobj.PRODUCT_NAME;
	gobj.gobjPCUU.setIcon(document.title, "Internet Explorer_TridentDlgFrame", gobj.ICON);
	var rssinfo_body = document.getElementById("rssinfo-body");
	if(gobj.RSS_NEW_ITEM_EXIST || gobj.RSS_UPDATE_ITEM_EXIST) rssinfo_body.style.visibility = "visible";
	else rssinfo_body.style.visibility = "hidden";
	if(!gobj.RSS_NEW_ITEM_EXIST && !gobj.RSS_UPDATE_ITEM_EXIST) { // XVȂ
		document.getElementById("rss-none-body").innerHTML = "<table><tr><th>XV</th></tr><tr><td>" + gobj.RSS_NONE_UPDATE_TEXT + "</td></tr>";
		return;
	}
	else {
		document.getElementById("rss-none-body").style.visibility = "hidden";
	}
	var newHtml = "<table><tr><th colspan=\"4\">V</th></tr>";
	var updateHtml = "<table><tr><th colspan=\"4\">XV</th></tr>";
	for(n = 0; n < gobj.RSS_ITEM_COUNT; n++) {
		var did = gobj.RSS_DATE_ID[n];
		var date_str = did.substring(0,4) + "N" + did.substring(4,6) + "" + did.substring(6,8) + "";
		var priority = gobj.RSS_ITEM_PRIORITY[did];
		priority = priority.length == 0 ? "&nbsp;" : priority;
		var html = "<tr><td class=\"date\">" + date_str + "</td>" +
								"<td class=\"priority\">" + priority + "</td>" +
								"<td class=\"title\">" + 
								"<a href=\"#\" onclick=\"return show_description(" + did + ");\"><div id=\"etitle" + did + "\" class=\"etitle\">" + gobj.RSS_ITEM_TITLE[did] + "</div></a>" +
								"<a href=\"#\" onclick=\"return show_description(" + did + ");\"><div id=\"ctitle" + did + "\" class=\"ctitle\">" + gobj.RSS_ITEM_TITLE[did] + "</div></a>" +
								"<div id=\"hline" + did + "\" class=\"hline\"></div>" +
								"<div id=\"desc" + did + "\" class=\"desc\" style=\"visibility=hidden;height=0px;\">" + 
								"<div class=\"dsc\">" + gobj.RSS_ITEM_DESCRIPTION[did] + "</div>" + 
								"<div class=\"goweb\">" + 
								"<a href=\"#\" onclick=\"return openlink(this);\" id=\"" + did + "\" onmouseover=\"document.goweb" + did + ".src='img/btn_web_o.gif';\" onmouseout=\"document.goweb" + did + ".src='img/btn_web.gif';\">" + 
								"<img name=\"goweb" + did +"\" width=\"63\" height=\"19\" src=\"img/btn_web.gif\" /></a></div>" + 
								//"<span class=\"link\">" + 
								//gobj.RSS_ITEM_LINK[did] + "</span>" +
								"</div></td>" +
								"<td class=\"category\">" + gobj.RSS_ITEM_CATEGORY[did] + "</td></tr>";
		if(gobj.RSS_ITEM_FLAG[did] == RSS_FLAG_NEW) newHtml += html;
		else if(gobj.RSS_ITEM_FLAG[did] == RSS_FLAG_UPDATE) updateHtml += html;
	}
	newHtml += "</table>";
	updateHtml += "</table>";
	if(gobj.RSS_NEW_ITEM_EXIST && gobj.RSS_UPDATE_ITEM_EXIST) {
		rssinfo_body.innerHTML = newHtml + updateHtml;
	}
	else if(gobj.RSS_UPDATE_ITEM_EXIST) {
		rssinfo_body.innerHTML = updateHtml;
	}
	else if(gobj.RSS_NEW_ITEM_EXIST) {
		rssinfo_body.innerHTML = newHtml;
	}
	a_dragDropDisable(this);
}

function show_description(did)
{
	var desc = document.getElementById("desc"+did);
	var etitle = document.getElementById("etitle"+did);
	var ctitle = document.getElementById("ctitle"+did);
	var hline = document.getElementById("hline"+did);
	if(desc.style.visibility == 'hidden') {
		etitle.style.height = '0px';
		etitle.style.visibility = 'hidden';
		ctitle.style.height = 'auto';
		ctitle.style.visibility = 'visible';
		hline.style.height = 'auto';
		hline.style.visibility = 'visible';
		desc.style.height = 'auto';
		desc.style.visibility = 'visible';
	}
	else {
		etitle.style.height = 'auto';
		etitle.style.visibility = 'visible';
		ctitle.style.height = '0px';
		ctitle.style.visibility = 'hidden';
		hline.style.height = '0px';
		hline.style.visibility = 'hidden';
		desc.style.height = '0px';
		desc.style.visibility = 'hidden';
	}
}

function getWinOS() {
	var objLoc = new ActiveXObject("WbemScripting.SWbemLocator");
	var objServiceWMI = objLoc.ConnectServer(null, "root\\cimv2");
	var prop = objServiceWMI.ExecQuery("SELECT * FROM Win32_OperatingSystem");
	var e = new Enumerator(prop);

	if(e.item().Caption.indexOf("Vista") != -1) {	// Vistȁꍇ
		return "Windows Vista";
	}
	if(e.item().Caption.indexOf("Windows 7") != -1) {	// Windows 7̏ꍇ
		return "Windows 7";
	}
	if(e.item().Caption.indexOf("Windows 8.1") != -1) {	// Windows 8.1̏ꍇ
		return "Windows 8.1";
	}
	if(e.item().Caption.indexOf("Windows 8") != -1) {	// Windows 8̏ꍇ
		return "Windows 8";
	}
	return "";
}
